import { Observable } from 'rxjs/Observable';
export declare class Model<T> {
    private _data;
    data$: Observable<T>;
    constructor(initialData: any, immutable: boolean, clone?: (data: T) => T);
    get(): T;
    set(data: T): void;
}
export declare class ModelFactory<T> {
    create(initialData: T): Model<T>;
    createMutable(initialData: T): Model<T>;
    createWithCustomClone(initialData: T, clone: (data: T) => T): Model<T>;
}
export declare function useModelFactory(): ModelFactory<{}>;
export declare const MODEL_PROVIDER: {
    provide: typeof ModelFactory;
    useFactory: () => ModelFactory<{}>;
};
